c===========================================================
c     tenv: Illustrates use of 'getenv' subroutine, 
c     available on most Unix systems, to fetch contents
c     of an environment variable.
c
c     To run demo:
c
c     % make test
c     % setenv DATA `pwd`
c     % tenv
c===========================================================
      program       tenv
      implicit      none

      integer       indlnb,   getu

      character*128 envval,   fname,   fline
      integer       u,  rc

c--   Fetch the value of the environment vbl. and verify that it 
c--   is set to some non-null value ...

      call getenv('DATA',envval)
      if( envval .eq. ' ' ) then
         write(0,*) 'tenv: Environment variable DATA is not set.'
         stop
      end if

c--   Construct the filenname and attempt to open the file ...

      fname = envval(1:indlnb(envval))//'/file.dat'
      write(0,*) 'tenv: Attempting to open <'//
     &   fname(1:indlnb(fname))//'>'
      u = getu()
      open(u,file=fname(1:indlnb(fname)),status='old',
     &     form='formatted',iostat=rc)

      if( rc .ne. 0 ) then
         write(0,*) 'tenv: Error opening <'//
     &   fname(1:indlnb(fname))//'>'
      end if

c--   Read and echo the contents of the file, then close 
c--   the file ...

      rc = 0
      do while( rc .eq. 0 ) 
         read(u,fmt='(a)',iostat=rc) fline
         if( rc .eq. 0 ) write(*,*) fline(1:indlnb(fline))
      end do

      close(u)

      stop
      end
